/**
  * @module pp-test-node
  *
  * Simple calculator API hosted on APIMATIC
  */

'use strict';

const Configuration = require('./configuration');
const SimpleCalculatorController = require('./Controllers/SimpleCalculatorController');
const OperationTypeEnum = require('./Models/OperationTypeEnum');
const APIException = require('./Exceptions/APIException');


const initializer = {
    // functional components of pp-test-node
    Configuration,
    // controllers of pp-test-node
    SimpleCalculatorController,
    // models of pp-test-node
    OperationTypeEnum,
    // exceptions of pp-test-node
    APIException,
};

module.exports = initializer;
